//
//  ViewController.swift
//  ImagePushExample
//
//  Created by TaeSu Lee on 2017. 8. 4..
//  Copyright © 2017년 TaeSu Lee. All rights reserved.
//

import UIKit
import UserNotifications

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBAction fileprivate func touchUpInsideLocalPush(_ sender: UIButton) {
        let content = UNMutableNotificationContent()
        content.title = "로컬 타이틀"
        content.body = "로컬 바디"
        content.sound = UNNotificationSound.default()
        content.categoryIdentifier = "image-message"
        
        let imageURLString = "https://i.ytimg.com/vi/7qkbRYM7YP8/maxresdefault.jpg"
        if let imagePath = DownloadManager.image(imageURLString) {
            let imageURL = URL(fileURLWithPath: imagePath)
            do {
                let attach = try UNNotificationAttachment(identifier: "imate-test", url: imageURL, options: nil)
                content.attachments = [attach]
            } catch {
                print(error)
            }
        }
        
        // Deliver the notification in five seconds.
        let trigger = UNTimeIntervalNotificationTrigger(timeInterval: 5, repeats: false)
        let request = UNNotificationRequest(identifier: "FiveSecond", content: content, trigger: trigger) // Schedule the notification.
        let center = UNUserNotificationCenter.current()
        center.add(request) { (error : Error?) in
            if let theError = error {
                print(theError)
            }
        }
    }
}

