//
//  NotificationService.swift
//  NotificationServiceExtension
//
//  Created by TaeSu Lee on 2017. 8. 4..
//  Copyright © 2017년 TaeSu Lee. All rights reserved.
//

import UserNotifications

class NotificationService: UNNotificationServiceExtension {

    var contentHandler: ((UNNotificationContent) -> Void)?
    var bestAttemptContent: UNMutableNotificationContent?

override func didReceive(_ request: UNNotificationRequest, withContentHandler contentHandler: @escaping (UNNotificationContent) -> Void) {
    self.contentHandler = contentHandler
    bestAttemptContent = (request.content.mutableCopy() as? UNMutableNotificationContent)
    
    if let bestAttemptContent = bestAttemptContent {
        // Modify the notification content here...
        bestAttemptContent.title = "\(bestAttemptContent.title) [modified]"
        bestAttemptContent.badge = 10
        
        if let imageURLString = bestAttemptContent.userInfo["image-url"] as? String {
            if let imagePath = DownloadManager.image(imageURLString) {
                let imageURL = URL(fileURLWithPath: imagePath)
                do {
                    let attach = try UNNotificationAttachment(identifier: "image-test", url: imageURL, options: nil)
                    bestAttemptContent.attachments = [attach]
                } catch {
                    print(error)
                }
            }
        }
        
        contentHandler(bestAttemptContent)
    }
}
    
    override func serviceExtensionTimeWillExpire() {
        // Called just before the extension will be terminated by the system.
        // Use this as an opportunity to deliver your "best attempt" at modified content, otherwise the original push payload will be used.
        if let contentHandler = contentHandler, let bestAttemptContent =  bestAttemptContent {
            contentHandler(bestAttemptContent)
        }
    }
}
